<?php
namespace Helper\LabelsLoader;
use stdClass;
/**
 * Lobels Loader Controller
 */
class LabelsLoader {
  
  private $path;
  private $cookie;
  private $defaultLang;

  private $defaultCookieName = "language";
  
  public function __construct($argv = null) {
    if (isset($argv)) {
      $this->path   = $argv["filePath"];
      $this->defaultLang = $argv["defaultLang"];
      
      if(isset($argv["cookieName"])) {
        $this->cookie = $argv["cookieName"];
        if(!isset($_COOKIE[$this->cookie])) {
          setcookie($this->cookie, $this->defaultLang, time() + (10 * 365 * 24 * 60 * 60),"/");
        }
      } else { 
        $this->cookie = $this->defaultCookieName; 
      }
    }
  }
  
  /* Load the language from a file */
  public function label($id, $lang = null, $path = null) {
    if (isset($_COOKIE[$this->cookie])) {
      $currentLang = $_COOKIE[$this->cookie];
    } else {
      $currentLang = $this->defaultLang;
    }

    if ($lang == NULL)
      $lang = $currentLang;
    
    if ($path == NULL)
      $path = $this->path;
    
    return $this->getLabel($path, $lang, $id);
  }
  
  /* Get label from path */
  private function getLabel($path, $lang, $label) {
    
    $lang = strtoupper($lang);
    if (file_exists($path)) {
      $json  = file_get_contents($path, 0, null, null);
      $json1 = json_decode($json, TRUE);

      if (!empty($json1[$lang][0][$label])) {
        return $json1[$lang][0][$label];
      } else {
        return "Warning: Label " . $label . " does not exist!";
      }
    } else {
      return "ERROR: File not found!";
    }
  }  

  public function setLang($lang) {
    setcookie($this->cookie, $lang, time() + (10 * 365 * 24 * 60 * 60),"/");
    $_COOKIE[$this->cookie] = $lang; 
  }

}